// Display.cpp : implementation file
//

#include "stdafx.h"
#include "TWViewer.h"
#include "Display.h"
#include <wingdi.h>
#include <io.h>
#include <twihm.h>
#include <twgensolver.h>
#include "inprop.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

POINT			*m_points;
int				m_nbpoints;
int				m_nbsom;
VALUE			real_surf;
VALUE			real_perim;
VALUE			poly_method;
VALUE			colrate;



void BSort(WORD *tab,DWORD nbelem)
{
	DWORD i=0;
	WORD tmp;
	while(i<nbelem-1)
	{
		tab[i]%=m_nbpoints;
		tab[i+1]%=m_nbpoints;
		if(tab[i]>tab[i+1])
		{
			tmp=tab[i];
			tab[i]=tab[i+1];
			tab[i+1]=tmp;
			i=0;
		}
		else ++i;
	}
}
//essai sur 8 sommets
VALUE Fitness(void * p2)
{
	WORD *tab=(WORD*)p2;
	VALUE tmp,res=0,resp=0;

	BSort(tab,m_nbsom);
	for(int i=1;i<m_nbsom;i++)
	{
		//surf
		res+= (m_points[tab[i-1]].x + m_points[tab[i]].x) * (m_points[tab[i]].y - m_points[tab[i-1]].y);
		//perim
		tmp=(m_points[tab[i-1]].x - m_points[tab[i]].x);
		tmp*=tmp;
		tmp+=(m_points[tab[i-1]].y - m_points[tab[i]].y)*(m_points[tab[i-1]].y - m_points[tab[i]].y);
		resp+=sqrt(tmp);
	}
	//surf
	res+=(m_points[tab[m_nbsom-1]].x + m_points[tab[0]].x) * (m_points[tab[0]].y - m_points[tab[m_nbsom-1]].y);
	//perim
	tmp=(m_points[tab[0]].x - m_points[tab[m_nbsom-1]].x);
	tmp*=tmp;
	tmp+=(m_points[tab[0]].y - m_points[tab[m_nbsom-1]].y)*(m_points[tab[0]].y - m_points[tab[m_nbsom-1]].y);
	resp+=sqrt(tmp);

	if(res<0) res=-res;
	//surf
	res/=real_surf;
	res*=poly_method;
	//res=2* aire
	//perim
	resp/=real_perim;
	resp*=(1-poly_method);
	
	return res+resp;
}

/////////////////////////////////////////////////////////////////////////////
// CDisplay

CDisplay::CDisplay()
{
	m_nbsom=0;
	colrate=0.9;
	poly_method=1;
	m_nbsolpoly=0;
	m_points=NULL;
	m_nbpoints=0;
	m_pictmode=PM_ZOOM;
	m_mode=NOTHING_MODE;
	bmp=NULL;
	TWSTRING fic(100);
	curimg=0;
	drag=false;
	zoomed=false;

	long hfile;
	struct _finddata_t c_file;

	hfile = _findfirst( "*.bmp", &c_file );
	if(hfile == -1L ) return;
	fic=c_file.name;
	colfic.Add(fic);
	while( _findnext( hfile, &c_file ) == 0 )
	{
		fic=c_file.name;
		colfic.Add(fic);
	}
    _findclose( hfile );
}

CDisplay::~CDisplay()
{
	ReleaseHBitmap();
	SAFEDELA(m_points);
}


BEGIN_MESSAGE_MAP(CDisplay, CStatic)
	//{{AFX_MSG_MAP(CDisplay)
	ON_WM_PAINT()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEWHEEL()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_CHAR()
	ON_COMMAND(ID_IMAGE_MODE_ZOOM, OnImageModeZoom)
	ON_COMMAND(ID_IMAGE_PROJETIN, OnImageProjetIN)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplay message handlers

void CDisplay::OnPaint() 
{
	CDC *dc;
	PAINTSTRUCT ps;
	RECT rect;
	m_handle=m_hWnd;

	GetParent()->GetClientRect(&rect);

	dc=BeginPaint(&ps);

	switch(m_mode)
	{
	case PICT_MODE:
		DrawPicture(dc);
		break;
	case OBJECT_MODE:
		break;
	case WORLD_MODE:
		break;
	case WAIT_MODE:
	case WAIT_MODE_WRL:
	case WAIT_MODE_3D:
		dc->SetTextColor(0xCCCCCC);
		dc->SetBkColor(0);
		dc->FillSolidRect(0,0,rect.right,rect.bottom,0xAA0000);
		dc->DrawText(m_waitstr.GetBuffer(),m_waitstr.GetLength(),&rect,0);
		break;
	case NOTHING_MODE:
		dc->FillSolidRect(0,0,rect.right,rect.bottom,0xAA0000);
		break;
	}
	

	EndPaint(&ps);
	
}

void CDisplay::OnRButtonUp(UINT nFlags, CPoint point) 
{
	zoomed=false;
	drag=false;
	Invalidate();
	CStatic::OnRButtonUp(nFlags, point);
}

BOOL CDisplay::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	/*if(colfic.GetSize()) 
	{
		if(zDelta<0) --curimg;
		else ++curimg;
		if(curimg<0) curimg=colfic.GetSize()-1;
		curimg%=colfic.GetSize();
		m_picture.LoadFromBmp(colfic[curimg]);
		m_picture.SetPixelFormat(PF_RGB32);
		drag=false;
		zoomed=false;
		TWSTRING str="TWViewer - "+colfic[curimg]; 
		GetParent()->SetWindowText(str);
		Invalidate();
	}
	*/
	if((m_pictmode==PM_SELECT_POLY) || (m_pictmode==PM_SELECT_SHAPE))
	{
		int pas=m_nbsolpoly>>2;
		if(!pas) pas=1;
		if(zDelta<0) m_nbsolpoly-=pas;
		else m_nbsolpoly+=pas;
		if(m_nbsolpoly>=m_nbpoints) m_nbsolpoly=m_nbpoints-1;
		else if(m_nbsolpoly<0) m_nbsolpoly=0;
		TWSTRING str;
		str.FromInt(m_nbsolpoly);
		str="#"+str;
		GetParent()->SetWindowText(str);
		Invalidate();
	}
	return CStatic::OnMouseWheel(nFlags, zDelta, pt);
}

void CDisplay::OnMouseMove(UINT nFlags, CPoint point) 
{
	static CPoint tmp=point;
	switch(m_mode)
	{
	case PICT_MODE:
		if((drag) && (!zoomed))
		{
			if(point.x<zoom.left) zoom.left=point.x;
			else if(point.x>zoom.right) zoom.right=point.x;
			if(point.y<zoom.top) zoom.top=point.y;
			else if(point.y>zoom.bottom) zoom.bottom=point.y;
			Invalidate();
		}
		break;
	case WORLD_MODE:
	case OBJECT_MODE:
		tmp-=point;
		m_camera.RotateBy(tmp.y,tmp.x,0);
		m_world.Render();
		break;
	}
	tmp=point;
	CStatic::OnMouseMove(nFlags, point);
}

void CDisplay::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if((m_pictmode==PM_ZOOM) && (!zoomed))
	{
		drag=true;
		zoom.left=point.x;
		zoom.top=point.y;
		zoom.right=point.x;
		zoom.bottom=point.y;
	}
	else 
	{
		VALUE tmp;
		TWCOLLECTION <DWORD> col;
		RECT rect;
		GetWindowRect(&rect);
		point.x*=m_picture.GetWidth();
		point.x/=(rect.right-rect.left);
		point.y*=m_picture.GetHeight();
		point.y/=(rect.bottom-rect.top);
		point.y=m_picture.GetHeight()-point.y;
		m_nbpoints=m_picture.GetShape(col,point.x,point.y,colrate);
		SAFEDELA(m_points);
		if(!m_nbpoints) return;
		col.GotoHead();
		m_points=new POINT[m_nbpoints];
	
		//on fixe les points et on calcule la surface relle
		real_surf=0;
		real_perim=0;
		for(int i=0;i<m_nbpoints;i++)
		{
			m_points[i].x=col.GetCurrent()%m_picture.GetWidth();
			m_points[i].y=col.GetCurrent()/m_picture.GetWidth();
			if(i) 
			{
				real_surf+= (m_points[i-1].x + m_points[i].x) * (m_points[i].y - m_points[i-1].y);
				tmp=(m_points[i-1].x - m_points[i].x);
				tmp*=tmp;
				tmp+=(m_points[i-1].y - m_points[i].y)*(m_points[i-1].y - m_points[i].y);
				real_perim+=sqrt(tmp);
			}
			col.GotoNext();
		}
		real_surf+=(m_points[m_nbpoints-1].x + m_points[0].x) * (m_points[0].y - m_points[m_nbpoints-1].y);
		if(real_surf<0) real_surf=-real_surf;
		//perim
		tmp=(m_points[m_nbpoints-1].x - m_points[0].x);
		tmp*=tmp;
		tmp+=(m_points[m_nbpoints-1].y - m_points[0].y)*(m_points[m_nbpoints-1].y - m_points[0].y);
		real_perim+=sqrt(tmp);
		//et on balance l'algo genetique
		if(m_pictmode==PM_SELECT_POLY)
		{
			solver.SetFitness(Fitness);
			solver.SetPopulation(100,(m_nbsom*sizeof(WORD))<<3,TWGS_MAX,0.2);

			solver.Solve(10);
			m_nbsolpoly=0;			
	
		}
		Invalidate();
	}
	
	CStatic::OnLButtonDown(nFlags, point);
}

void CDisplay::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(drag)
	{
		if(zoom.bottom-zoom.top<10) zoom.bottom=0;
		else if(zoom.right-zoom.left<10) zoom.right=0;
		else zoomed=true;
		Invalidate();
	}
	drag=false;
	
	CStatic::OnLButtonUp(nFlags, point);
}

void CDisplay::DrawPicture(CDC *dc)
{
	CDC tmpdc;
	RECT rect,zrect;


	GetClientRect(&rect);

	
	if((m_pictmode==PM_ZOOM) && (zoomed) && (zoom.right) && (zoom.bottom))
	{
		zrect.left=(zoom.left*m_picture.GetWidth())/rect.right;
		zrect.top=(zoom.top*m_picture.GetHeight())/rect.bottom;
		zrect.right=(zoom.right*m_picture.GetWidth())/rect.right;
		zrect.bottom=(zoom.bottom*m_picture.GetHeight())/rect.bottom;
		zrect.right-=zrect.left;
		zrect.bottom-=zrect.top;
	}
	else
	{
		zrect.left=0;
		zrect.top=0;
		zrect.right=m_picture.GetWidth();
		zrect.bottom=m_picture.GetHeight();
	}
	
	tmpdc.CreateCompatibleDC(&tmpdc);
	
	
	SelectObject(tmpdc.m_hDC,bmp);
	dc->StretchBlt( 0,0,rect.right,rect.bottom,&tmpdc,zrect.left,zrect.top,zrect.right,zrect.bottom,SRCCOPY);
	
	if((drag) && (!zoomed))
	{
		dc->DrawEdge(&zoom,EDGE_BUMP,BF_RECT);
	}
	if(m_pictmode==PM_SELECT_SHAPE)
	{
		POINT p;
		for(int i=0;i<m_nbsolpoly;i++)
		{			
			p=m_points[i];
			p.x*=(rect.right-rect.left);
			p.x/=m_picture.GetWidth();
			p.y=m_picture.GetHeight()-p.y;
			p.y*=(rect.bottom-rect.top);
			p.y/=m_picture.GetHeight();
			dc->SetPixel(p,0xFFFFFF);
		}
	}
	else if(m_pictmode==PM_SELECT_POLY)
	{
		CPen pen;
		WORD *sol=(WORD*)solver.GetSolution(m_nbsolpoly);
		if(!sol) {tmpdc.DeleteDC();return;}
		LOGPEN lpen;
		lpen.lopnColor=0xFFFFFF;
		lpen.lopnStyle=PS_SOLID;
		lpen.lopnWidth.x=1;

		pen.CreatePenIndirect(&lpen);
		dc->SelectObject(&pen);

		POINT p;
		for(int i=0;i<m_nbsom+1;i++)
		{
			p=m_points[sol[i%m_nbsom]];
			p.x*=(rect.right-rect.left);
			p.x/=m_picture.GetWidth();
			p.y=m_picture.GetHeight()-p.y;
			p.y*=(rect.bottom-rect.top);
			p.y/=m_picture.GetHeight();
			if(!i) dc->MoveTo(p);
			else dc->LineTo(p);
		}
		pen.DeleteObject();
			
	}
	tmpdc.DeleteDC();

}

void CDisplay::CreateHBitmap()
{
	BITMAPINFO binfo;
	void *ptr;

	binfo.bmiHeader.biSize=sizeof(binfo.bmiHeader);
	binfo.bmiHeader.biWidth=m_picture.GetWidth();
	binfo.bmiHeader.biHeight=m_picture.GetHeight();
    binfo.bmiHeader.biXPelsPerMeter=92;//m_picture.GetHPPM();
	binfo.bmiHeader.biYPelsPerMeter=92;//m_picture.GetVPPM();
    binfo.bmiHeader.biPlanes=1; 
    binfo.bmiHeader.biBitCount=32; 
    binfo.bmiHeader.biCompression=BI_RGB; 
    binfo.bmiHeader.biSizeImage=0; 
    binfo.bmiHeader.biClrUsed=0; 
    binfo.bmiHeader.biClrImportant=0; 

	ReleaseHBitmap();
	m_picture.SetPixelFormat(PF_RGB32,0xFF0000,0xFF00,0xFF,0xFF000000);
	bmp=CreateDIBSection(GetDC()->m_hDC,&binfo,DIB_RGB_COLORS,&ptr,NULL,NULL);
	if(bmp) memcpy(ptr,m_picture.GetBuffer(),m_picture.GetBufferSize());
}

void CDisplay::ReleaseHBitmap()
{
	if(bmp!=NULL)
	{
		DeleteObject(bmp);
		bmp=NULL;
	}
}

void CDisplay::CreatePictureFromScreen()
{
	//BITMAP binfo;
	TWHANDLE han;
	CDC *dc=GetDC();

	han=m_hWnd;
	ReleaseHBitmap();
	m_picture.Release();
	m_picture.Create(han.GetWidth(),han.GetHeight(),32);
	TWCOLOR c;
	m_picture.SetMasks(0xFF0000,0xFF00,0xFF,0);
	int ind=0;
	for(int i=han.GetHeight();i>0;i--)
		for(int j=0;j<han.GetWidth();j++)
		{
			c.SetMasks(0xFF,0xFF00,0xFF0000,0);
			c.SetRGBA32(dc->GetPixel(j,i));
			m_picture.SetPixel(ind++,c);
		}
	CreateHBitmap();
}

//DEL void CDisplay::DrawText(TCHAR *txt)
//DEL {
//DEL 	RECT rc;
//DEL 	CDC * dc=GetDC();
//DEL 	rc.top=rc.left=0;
//DEL 	rc.bottom=20;
//DEL 	rc.right=100;
//DEL 	dc->DrawText(txt,50,&rc,DT_VCENTER|DT_CENTER);
//DEL }

void CDisplay::SetCurMod(TW3DMOD *mod)
{
	m_world.Set3DMod(mod);
}

void CDisplay::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch(nChar)
	{
	case 'Q':  m_camera.MoveLeft(10); break;
	case 'D': m_camera.MoveRight(10); break;
	case 'Z':    m_camera.MoveForward(10); break;
	case 'S':  m_camera.MoveBackward(10); break;
	}
	m_world.Render();

	//CStatic::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CDisplay::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CStatic::OnChar(nChar, nRepCnt, nFlags);
}


void CDisplay::OnImageModeZoom() 
{
	m_pictmode=PM_ZOOM;
}


void CDisplay::OnImageProjetIN() 
{
	CINProp propdlg;
	TWSTRING s;
	propdlg.m_mode=m_pictmode-1;
	s.FromInt(m_nbsom);
	propdlg.m_nbsom=s.GetBuffer();
	
	propdlg.m_prate=(int)(colrate*100);
	propdlg.m_fitrate=(int)(poly_method*100);

	if(propdlg.DoModal()==IDCANCEL) return;

	poly_method=propdlg.m_fitrate;
	poly_method/=100;
	m_pictmode=propdlg.m_mode+1;
	s=propdlg.m_nbsom.GetBuffer(5);
	m_nbsom=s.ParseInt();
	colrate=propdlg.m_prate;
	colrate/=100;
}
