#if !defined(AFX_DISPLAY_H__B20D2455_AAE2_43BB_BB5E_F643B85B8134__INCLUDED_)
#define AFX_DISPLAY_H__B20D2455_AAE2_43BB_BB5E_F643B85B8134__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Display.h : header file
//
#include <tw3dcore.h>
#include <tw2dcore.h>
#include <twcollection.h>
#include <twihm.h>
#include <twgensolver.h>

#define PM_SELECT_SHAPE	0x1
#define PM_ZOOM			0x0
#define PM_SELECT_POLY	0x2

#define PICT_MODE		0x1
#define OBJECT_MODE		0x2
#define WORLD_MODE		0x3
#define NOTHING_MODE	0x0

#define WAIT_MODE		0x10
#define WAIT_MODE_WRL	0x12
#define WAIT_MODE_3D	0x13
/////////////////////////////////////////////////////////////////////////////
// CDisplay window



class CDisplay : public CStatic
{
private:
	HBITMAP bmp;
	TWSTRING			m_waitstr;
	TWGENETICSOLVER		solver;

public:
	TWHANDLE			m_handle;
	TWPICTURE			m_picture;
	TWWORLD				m_world;
	TWOBJECT3D			m_object;
	TWCAMERA			m_camera;
	TWLIGHT				m_light;
	int					m_mode;	//obj,world ou 2d
	int					m_pictmode;



	TWCOLLECTION<TWSTRING> colfic;
	CDisplay();

// Attributes
public:
	void		SetMode(int m)				{m_mode=m;}
	void		SetWaitStr(TCHAR *s)		{m_waitstr=s;}

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDisplay)
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetCurMod(TW3DMOD *mod);
	void CreatePictureFromScreen();
	void ReleaseHBitmap();
	void CreateHBitmap();
	void DrawPicture(CDC *dc);
	virtual ~CDisplay();

	// Generated message map functions
protected:
	int m_nbsolpoly;
	int curimg;
	RECT zoom;
	bool zoomed,drag;
	//{{AFX_MSG(CDisplay)
	afx_msg void OnPaint();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnImageModeZoom();
	afx_msg void OnImageProjetIN();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISPLAY_H__B20D2455_AAE2_43BB_BB5E_F643B85B8134__INCLUDED_)
