// TWViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TWViewer.h"
#include "TWViewerDlg.h"
#include "ResizeDlg.h"
#include "jpegdlg.h"
#include "PropertiesDlg.h"

#include <TWIHM.h>
#include <TW3DStdPrim.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTWViewerDlg dialog

CTWViewerDlg::CTWViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTWViewerDlg::IDD, pParent)
{
	curmod=NULL;
	//{{AFX_DATA_INIT(CTWViewerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTWViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTWViewerDlg)
	DDX_Control(pDX, IDC_DISPLAY, m_display);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTWViewerDlg, CDialog)
	//{{AFX_MSG_MAP(CTWViewerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveAs)
	ON_COMMAND(ID_HELP_ABOUT, OnAbout)
	ON_COMMAND(ID_IMAGE_VFLIP, OnImageVflip)
	ON_WM_SIZE()
	ON_COMMAND(ID_IMAGE_RESIZE, OnImageResize)
	ON_COMMAND(ID_IMAGE_DOUBLESIZEBLUR, OnImageDoublesizeblur)
	ON_COMMAND(ID_3D_RUNRENDERERDEMO, On3DRunDemo)
	ON_COMMAND(ID_EDIT_PROPERTIES, OnEditProperties)
	ON_COMMAND(ID_FILE_EXIT, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTWViewerDlg message handlers

BOOL CTWViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitLoadable();
	if(param!="") FileOpen(param);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTWViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) OnAbout();
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTWViewerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTWViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTWViewerDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CTWViewerDlg::OnFileOpen() 
{
	TWSTRING fic(200),typ(500);
	if(!GetSupportedFiles(typ))
	{
		MessageBox("No loading modules available","TWViewer error");
		return;
	}

	
	TWOpenFileDialog(fic,typ);
	fic.ResetSize();
	if(fic=="") return;
	FileOpen(fic);

	m_display.Invalidate();
}

void CTWViewerDlg::OnFileSaveAs() 
{
	if(!m_suppformats.GetSize())
	{
		MessageBox("No loading modules available","TWViewer error");
		return;
	}

	TWSTRING tmp,fic(100);
	TWSTRING ext(500);

	for(int i=0;i<m_suppformats.GetSize();i++)
	{
		m_suppformats[i].GetSubString(tmp,0,'|');
		ext+=tmp;
		ext+='\0';
		m_suppformats[i].GetSubString(tmp,1,'|');
		ext+="*.";
		ext+=tmp;
		ext+='\0';
	}
	ext+='\0';
	TWSaveFileDialog(fic,ext);
	fic.ResetSize();
	if(fic=="") return;

	FileSave(fic);
}

void CTWViewerDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CTWViewerDlg::OnImageVflip() 
{
	m_display.m_picture.VFlip();
	m_display.Invalidate();
	
}

void CTWViewerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if((m_display.m_hWnd) && (m_display.IsWindowVisible())) 
	{
		RECT rc;
		rc.left=0;
		rc.top=0;
		rc.right=cx;
		rc.bottom=cy;
		m_display.SetWindowPos(NULL,rc.left,rc.top,rc.right,rc.bottom,0);
		m_display.Invalidate();
	}
	
}

void CTWViewerDlg::OnImageResize() 
{
	TWSTRING sw,sh;
	CResizeDlg dlg;
	sw.FromInt(m_display.m_picture.GetWidth());
	sh.FromInt(m_display.m_picture.GetHeight());
	dlg.m_width=sw;	
	dlg.m_height=sh;
	
	if(dlg.DoModal()!=IDOK) return;

	sw=dlg.m_width;
	sh=dlg.m_height;
	m_display.m_picture.Resize(sw.ParseInt()-(sw.ParseInt()%8),sh.ParseInt());
	m_display.Invalidate();
	
}

int CTWViewerDlg::DoModal(TCHAR *p) 
{
	param=p;
	param.TrimLeft('\"');
	param.TrimRight('\"');
	return CDialog::DoModal();
}

bool CTWViewerDlg::FileOpen(TWSTRING &fic)
{
	TWSTRING ext;
	fic.GetSubString(ext,1,'.');
	ext.ToLowerCase();
	

	m_display.SetMode(WAIT_MODE);
	m_display.SetWaitStr("Loading from file...");
	m_display.RedrawWindow();

	//peter tout!!!!! (si objet mode non, sinon si)
	//world.Release();
	
	if(m_display.m_picture.LoadFromFile(fic)) 
	{
		m_display.SetMode(PICT_MODE);
		m_display.CreateHBitmap();
	}
	else if(m_display.m_object.LoadFromFile(fic)) 
	{
		m_display.m_camera.SetPosition(-1,0,1);
		m_display.m_camera.Look(0, 0, 0);
		m_display.m_camera.SetFOV(45.0);
		m_display.m_world.AddCamera(&m_display.m_camera);
		m_display.m_world.Add(&m_display.m_object);
		m_display.SetMode(OBJECT_MODE);
		m_display.m_world.Render();

	}
	else if(m_display.m_world.LoadFromFile(fic))
	{
		if(!curmod)
		{
			m_display.SetMode(WAIT_MODE_WRL);
			m_display.SetWaitStr("Please select a renderer");
			m_display.RedrawWindow();
		}
		m_display.SetMode(WORLD_MODE);
		m_display.m_world.Render();
	}
	else 
	{
		TWAlert("Unloadable file");
		m_display.SetMode(NOTHING_MODE);
		return false;
	}

	return true;
}


void CTWViewerDlg::ClearScene()
{
	m_display.m_world.DeleteAllObjects();
	m_display.m_world.Release();
}

void CTWViewerDlg::OnImageDoublesizeblur() 
{
	m_display.m_picture.AAliasDouble(5);
	m_display.Invalidate();
	
}

void CTWViewerDlg::InitLoadable()
{
	m_renderidmin=m_renderidmax=33000;
	int i=0;
	const int MENID=3;
	CMenu * main=GetMenu(),*popup=new CMenu;
	main->EnableMenuItem(MENID,MF_BYPOSITION|MF_GRAYED);

	TW3DMOD *mod;
	modmanager.Load("3D Renderer");
	if(modmanager.GetNbModules())
	{
		main->EnableMenuItem(MENID,MF_BYPOSITION|MF_ENABLED);
		popup->CreateMenu();
		main=main->GetSubMenu(MENID);
		main->InsertMenu(0,MF_BYPOSITION|MF_POPUP,(UINT)popup->m_hMenu,"Installed Renderers");
	}
	for(i=0;i<modmanager.GetNbModules();i++)
	{
		mod=(TW3DMOD*)modmanager[i];
		popup->AppendMenu(MF_STRING,m_renderidmax++,mod->GetName().GetBuffer());
	}

	m_display.m_picture.GetSupportedFiles(m_suppformats);
	m_display.m_object.GetSupportedFiles(m_suppformats3d);
	m_display.m_world.GetSupportedFiles(m_suppformatswrl);
	

	SAFEDEL(popup);
	
}

void CTWViewerDlg::Init3D()
{
	/*TWITEM wind;
	if(mode==1)	//object
	{
		curmod.Init(wind);
		camera.SetPosition(5,0,-10);
		camera.SetLookAt(0,0,0);
		light.SetPosition(10,10,-10);
		world.Release();
		world.Add(object);
		world.AddCamera(camera);
		world.AddLight(light);
	}
	else if(mode!=2) return;	//world
	world.Set3DMod(curmod);
	world.Init();*/
}

void CTWViewerDlg::On3DRunDemo() 
{
	TWHANDLE handle;
	handle=m_display.m_hWnd;
	if(!curmod) return;
	m_display.SetMode(WORLD_MODE);
	if(curmod->GetModAvgSpeed()==0)
	{
		m_display.SetWaitStr("Rendering in progress...");
		m_display.SetMode(WAIT_MODE);
		m_display.RedrawWindow();
		m_display.SetMode(WORLD_MODE);
		curmod->DrawSampleScene();
		m_display.CreatePictureFromScreen();
		m_display.m_mode=PICT_MODE;
	}
	else curmod->DrawSampleScene();
}

void CTWViewerDlg::FileSave(const TWSTRING & fname)
{
	if(m_display.m_mode==0) m_display.m_picture.SaveToFile(fname.GetBuffer());
	else if(m_display.m_mode==1) m_display.m_object.SaveToFile(fname.GetBuffer());
	else m_display.m_world.SaveToFile(fname.GetBuffer());
}

WORD ExtractInfo(TWCOLLECTION <TWSTRING> &col, TWSTRING &all, TWSTRING &idp)
{
	TWSTRING exta,tmp;
	WORD res=0;
	idp="";
	for(WORD i=0;i<col.GetSize();i++)
	{
		++res;
		col[i].GetSubString(tmp,0,'|');
		idp+=tmp;
		idp+='\0';
		col[i].GetSubString(tmp,1,'|');
		idp+="*.";
		idp+=tmp;
		idp+='\0';
		all+=tmp;
		all+=", ";
		exta+="*.";
		exta+=tmp;
		exta+=';';
	}
	if(res)
	{
		exta.GetBuffer()[exta.GetLength()-1]=0;
		exta.ResetSize();
		all.GetBuffer()[all.GetLength()-2]=0;
		all.ResetSize();
		all+=")";
		all+='\0';
		all+=exta;
		//idp+='\0';
	}
	return res;
}

WORD CTWViewerDlg::GetSupportedFiles(TWSTRING &all)
{
	WORD cnt,cnt3d,cntw;
	all="";	

	TWSTRING allp,all3d,allw,lp,l3d,lw;
	TWSTRING liste,allt;
	all.Rebuild(500);
	allp="Any loadable image (";
	all3d="Any loadable object (";
	allw="Any loadable world (";

	cnt=ExtractInfo(m_suppformats,allp,lp);
	cnt3d=ExtractInfo(m_suppformats3d,all3d,l3d);
	cntw=ExtractInfo(m_suppformatswrl,allw,lw);

	TCHAR *ptr=all.GetBuffer();
	TCHAR *ptrl=liste.GetBuffer();

	if(cnt)
	{	
		all+=allp;
		all+='\0';
		liste+=lp;
	}
	if(cnt3d)
	{
		all+=all3d;
		all+='\0';
		liste+=l3d;
		cnt+=cnt3d;
	}
	if(cntw)
	{
		all+=allw;
		all+='\0';
		liste+=lw;
		cnt+=cntw;
	}
	all+="All (*.*)";
	all+='\0';
	all+="*.*";
	all+='\0';
	all+=liste;
	all+='\0';
	all+='\0';
	return cnt;
}

void CTWViewerDlg::OnEditProperties() 
{
	DWORD i,vc=0,fc=0;
	CPropertiesDlg prop;
	TWSTRING buf,tmp;
	switch(m_display.m_mode)
	{
	case 0:
		prop.SetTitle("Picture properties");
		buf="Width:				"; tmp.FromInt(m_display.m_picture.GetWidth()); buf+=tmp;buf+='\n';
		buf+="Height:			"; tmp.FromInt(m_display.m_picture.GetHeight()); buf+=tmp;buf+='\n';
		buf+="Depth:			"; tmp.FromInt(m_display.m_picture.GetPixelFormat()&0xFF); buf+=tmp;buf+='\n';
		buf+="HPPM:				"; tmp.FromInt(m_display.m_picture.GetHPPM()); buf+=tmp;buf+='\n';
		buf+="VPPM:				"; tmp.FromInt(m_display.m_picture.GetVPPM()); buf+=tmp;buf+='\n';
		buf+="Buffer size:		"; tmp.FromInt(m_display.m_picture.GetBufferSize()); buf+=tmp;buf+='\n';
		break;

	case 1:
		prop.SetTitle("Object properties");
		buf="Classname:			"; tmp=m_display.m_object.GetClassName(); buf+=tmp;buf+='\n';
		buf+="Nb faces:			"; tmp.FromInt(m_display.m_object.GetNbFaces()); buf+=tmp;buf+='\n';
		buf+="Nb vertices:		"; tmp.FromInt(m_display.m_object.GetNbVertices()); buf+=tmp;buf+='\n';
		buf+="Nb materials:		"; tmp.FromInt(m_display.m_object.GetNbMaterials()); buf+=tmp;buf+='\n';
		break;
	case 2:
		TWOBJECT3D *o;
		for(i=0;i<m_display.m_world.GetNbObjects();i++)
		{
			o=m_display.m_world.GetObject(i);
			fc+=o->GetNbFaces();
			vc+=o->GetNbVertices();
		}
		prop.SetTitle("World properties");
		buf+="Nb objects:		"; tmp.FromInt(m_display.m_world.GetNbObjects()); buf+=tmp;buf+='\n';
		buf+="Nb cameras:		"; tmp.FromInt(m_display.m_world.GetNbCameras()); buf+=tmp;buf+='\n';
		buf+="Nb lights:		"; tmp.FromInt(m_display.m_world.GetNbLights()); buf+=tmp;buf+='\n';
		buf+="Nb faces:			"; tmp.FromInt(fc); buf+=tmp;buf+='\n';
		buf+="Nb vertices:		"; tmp.FromInt(vc); buf+=tmp;buf+='\n';
		break;
	default:
		TWAlert("No properties available");
		return;
	}
	prop.SetPropText(buf);
	prop.DoModal();
	
}

void CTWViewerDlg::OnChangeRenderer(DWORD id)
{
	int ind=id-m_renderidmin;
	m_display.SetWaitStr("Loading renderer and (re)initializing world...");
	m_display.SetMode(WAIT_MODE);
	m_display.RedrawWindow();
	if(curmod)
	{
		curmod->ReleaseWorld(&m_display.m_world);
		curmod->Release();
		UncheckAllRenderer();
	}
	curmod=(TW3DMOD*)modmanager[ind];
	if(curmod->GetModAvgSpeed()==0) curmod->Init(&m_display.m_handle,256,256,32,FALSE);
	else curmod->Init(&m_display.m_handle,800,600,32,FALSE);
	m_display.SetCurMod(curmod);
	m_display.SetMode(NOTHING_MODE);
	m_display.RedrawWindow();
		

	const int MENID=3;
	CMenu * main=GetMenu();
	main=main->GetSubMenu(MENID);
	main=main->GetSubMenu(0);
	//main->ModifyMenu(ind,MF_BYPOSITION|MF_CHECKED);
}

BOOL CTWViewerDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (((DWORD)wParam>=m_renderidmin) && ((DWORD)wParam<=m_renderidmax)) OnChangeRenderer(wParam);
	m_display.SendMessage(WM_COMMAND,wParam,lParam);
	return CDialog::OnCommand(wParam, lParam);
}

void CTWViewerDlg::UncheckAllRenderer()
{
	const int MENID=3;
	curmod=NULL;
	CMenu * main=GetMenu();
	main=main->GetSubMenu(MENID);
	main=main->GetSubMenu(0);
	for(DWORD i=0;i<m_renderidmax-m_renderidmin;i++)
		main->ModifyMenu(i,MF_BYPOSITION|MF_UNCHECKED);
}

