// TWViewerDlg.h : header file
//

#if !defined(AFX_TWVIEWERDLG_H__0B15980B_A505_4DC5_8281_FA2B6AF4955A__INCLUDED_)
#define AFX_TWVIEWERDLG_H__0B15980B_A505_4DC5_8281_FA2B6AF4955A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <TWModule.h>
#include "display.h"

/////////////////////////////////////////////////////////////////////////////
// CTWViewerDlg dialog

class CTWViewerDlg : public CDialog
{
private:
	TWMODMANAGER		modmanager;
	TW3DMOD *			curmod;
	DWORD				m_renderidmin;
	DWORD				m_renderidmax;

public:
	void UncheckAllRenderer();
	void OnChangeRenderer(DWORD id);
	WORD GetSupportedFiles(TWSTRING &s);
	void FileSave(const TWSTRING & fname);
	void Init3D();
	TWCOLLECTION <TWSTRING> m_suppformats,m_suppformats3d,m_suppformatswrl;
	void InitLoadable();
	void ClearScene();
	

	bool FileOpen(TWSTRING &s);
	TWSTRING param;
	CTWViewerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTWViewerDlg)
	enum { IDD = IDD_TWVIEWER_DIALOG };
	CDisplay	m_display;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTWViewerDlg)
	public:
	virtual int DoModal(TCHAR *);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTWViewerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCancel();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSaveAs();
	afx_msg void OnAbout();
	afx_msg void OnImageVflip();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnImageResize();
	afx_msg void OnImageDoublesizeblur();
	afx_msg void On3DRunDemo();
	afx_msg void OnEditProperties();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TWVIEWERDLG_H__0B15980B_A505_4DC5_8281_FA2B6AF4955A__INCLUDED_)
